package intrinsic.mx.core;

public class UIComponent extends intrinsic.mx.core.FlexSprite implements intrinsic.mx.core.IUIComponent, intrinsic.mx.core.IStateClient, intrinsic.mx.core.IInvalidating, intrinsic.mx.core.IFlexDisplayObject, intrinsic.mx.validators.IValidatorListener, intrinsic.mx.core.IRepeaterClient, intrinsic.mx.core.IConstraintClient, intrinsic.mx.styles.ISimpleStyleClient, intrinsic.mx.core.IPropertyChangeNotifier, intrinsic.mx.styles.IStyleClient, intrinsic.mx.core.IFlexModule, intrinsic.mx.managers.IToolTipManagerClient, intrinsic.mx.automation.IAutomationObject, intrinsic.mx.core.IUID, intrinsic.mx.managers.ILayoutManagerClient, intrinsic.mx.core.IDeferredInstantiationUIComponent, intrinsic.mx.core.IChildList {

	/** Accessors */
	public double explicitMaxHeight;
	public double explicitMinWidth;
	public int instanceIndex;
	public double maxHeight;
	public intrinsic.Array activeEffects;
	public boolean doubleClickEnabled;
	public intrinsic.flash.display.DisplayObjectContainer owner;
	public intrinsic.mx.core.IFlexModuleFactory moduleFactory;
	public double scaleX;
	public double scaleY;
	public intrinsic.mx.styles.CSSStyleDeclaration styleDeclaration;
	public boolean initialized;
	public String id;
	public boolean enabled;
	public double explicitWidth;
	public intrinsic.mx.managers.ISystemManager systemManager;
	public intrinsic.mx.managers.IFocusManager focusManager;
	public Object styleName;
	public intrinsic.flash.display.Sprite focusPane;
	public String className;
	public Object inheritingStyles;
	public Object nonInheritingStyles;
	public boolean updateCompletePendingFlag;
	public boolean processedDescriptors;
	public Object parentDocument;
	public double measuredWidth;
	public boolean focusEnabled;
	public int nestLevel;
	public double y;
	public double x;
	public String automationName;
	public double measuredHeight;
	public boolean mouseFocusEnabled;
	public String toolTip;
	public Object automationTabularData;
	public boolean showInAutomationHierarchy;
	public intrinsic.flash.display.DisplayObjectContainer $parent;
	public intrinsic.Array automationValue;
	public intrinsic.flash.display.DisplayObjectContainer parent;
	public Object automationDelegate;
	public int numAutomationChildren;
	public String currentState;
	public double contentMouseX;
	public boolean cacheHeuristic;
	public double contentMouseY;
	public String errorString;
	public String validationSubField;
	public double explicitHeight;
	public int repeaterIndex;
	public String cachePolicy;
	public Object parentApplication;
	public double $width;
	public double width;
	public double height;
	public boolean isDocument;
	public intrinsic.Array instanceIndices;
	public intrinsic.flash.geom.Rectangle screen;
	public intrinsic.Array repeaters;
	public intrinsic.Array repeaterIndices;
	public double $height;
	public intrinsic.mx.core.UIComponentDescriptor documentDescriptor;
	public boolean isEffectStarted;
	public boolean isPopUp;
	public double percentWidth;
	public double explicitMinHeight;
	public double mouseX;
	public double $x;
	public double mouseY;
	public String uid;
	public double percentHeight;
	public double explicitMaxWidth;
	public double $y;
	public intrinsic.mx.core.UIComponentDescriptor descriptor;
	public intrinsic.mx.core.IRepeater repeater;
	public double baselinePosition;
	public Object document;
	public double minHeight;
	public boolean $visible;
	public intrinsic.Array tweeningProperties;
	public double minWidth;
	public double maxWidth;
	public double measuredMinHeight;
	public boolean visible;
	public double measuredMinWidth;
	public boolean includeInLayout;
	public intrinsic.Array filters;

	/** Variables */
	public int overlayReferenceCount;
	public double _explicitMaxWidth;
	public boolean invalidateDisplayListFlag;
	public double _explicitMaxHeight;
	public boolean invalidatePropertiesFlag;
	public intrinsic.mx.core.UIComponentDescriptor _documentDescriptor;
	public Object _affectedProperties;
	public double origBorderColor;
	public intrinsic.Array transitions;
	public intrinsic.flash.display.DisplayObjectContainer _parent;
	public intrinsic.mx.core.UIComponentDescriptor _descriptor;
	public double _height;
	public boolean invalidateSizeFlag;
	public Object _document;
	public Object automaticRadioButtonGroups;
	public String _toolTip;
	public double _width;
	public String _errorString;
	public intrinsic.Array states;
	public intrinsic.mx.core.UIComponent overlay;
	public boolean saveBorderColor;
	public int overlayColor;
	public intrinsic.Array _effectsStarted;
	public double _explicitMinHeight;

	/** Constants */
	public static final String VERSION = "version";
	public static final double DEFAULT_MEASURED_MIN_HEIGHT = 0;
	public static final double DEFAULT_MAX_HEIGHT = 0;
	public static final double DEFAULT_MEASURED_HEIGHT = 0;
	public static final double DEFAULT_MEASURED_WIDTH = 0;
	public static final double DEFAULT_MAX_WIDTH = 0;
	public static final double DEFAULT_MEASURED_MIN_WIDTH = 0;

	/** Class Accessors */

	/** Class variables */
	public static Object STYLE_UNINITIALIZED;
	public static intrinsic.Function dispatchEventHook;
	public static intrinsic.Function createAccessibilityImplementation;

/** Contructors */
public UIComponent() {
}


/** Static Methods */
public static native void resumeBackgroundProcessing();
public static native void suspendBackgroundProcessing();

/** Methods */
public native intrinsic.flash.display.DisplayObject getFocusObject();
public native void removingChild(intrinsic.flash.display.DisplayObject arg0);
public native void invalidateSize();
public native void effectFinished(intrinsic.mx.effects.EffectInstance arg0);
public native void setVisible(boolean arg0);
public native void setVisible(boolean arg0, boolean arg1);
public native void fillOverlay(intrinsic.mx.core.UIComponent arg0, int arg1);
public native void fillOverlay(intrinsic.mx.core.UIComponent arg0, int arg1, intrinsic.mx.graphics.RoundedRectangle arg2);
public native void invalidateProperties();
public native intrinsic.flash.display.DisplayObject removeChildAt(int arg0);
public native intrinsic.flash.display.DisplayObject removeChild(intrinsic.flash.display.DisplayObject arg0);
public native void parentChanged(intrinsic.flash.display.DisplayObjectContainer arg0);
public native void validateNow();
public native void removeOverlay();
public native boolean validateBaselinePosition();
public native intrinsic.mx.core.IFlexModuleFactory getFontContext(String arg0, boolean arg1, boolean arg2);
public native void initialize();
public native intrinsic.flash.display.InteractiveObject getFocus();
public native void setFocus();
public native void drawRoundRect(double arg0, double arg1, double arg2, double arg3);
public native void drawRoundRect(double arg0, double arg1, double arg2, double arg3, Object arg4);
public native void drawRoundRect(double arg0, double arg1, double arg2, double arg3, Object arg4, Object arg5);
public native void drawRoundRect(double arg0, double arg1, double arg2, double arg3, Object arg4, Object arg5, Object arg6);
public native void drawRoundRect(double arg0, double arg1, double arg2, double arg3, Object arg4, Object arg5, Object arg6, Object arg7);
public native void drawRoundRect(double arg0, double arg1, double arg2, double arg3, Object arg4, Object arg5, Object arg6, Object arg7, String arg8);
public native void drawRoundRect(double arg0, double arg1, double arg2, double arg3, Object arg4, Object arg5, Object arg6, Object arg7, String arg8, intrinsic.Array arg9);
public native void drawRoundRect(double arg0, double arg1, double arg2, double arg3, Object arg4, Object arg5, Object arg6, Object arg7, String arg8, intrinsic.Array arg9, Object arg10);
public native intrinsic.flash.text.TextLineMetrics measureText(String arg0);
public native boolean dispatchEvent(intrinsic.flash.events.Event arg0);
public native void setStyle(String arg0, Object arg1);
public native void setStyle(String arg0, int arg1);
public native void setStyle(String arg0, double arg1);
public native Object getStyle(String arg0);
public native intrinsic.flash.geom.Point globalToContent(intrinsic.flash.geom.Point arg0);
public native void addingChild(intrinsic.flash.display.DisplayObject arg0);
public native intrinsic.Array getEffectsForProperty(String arg0);
public native intrinsic.mx.managers.ISystemManager getNonNullSystemManager();
public native boolean initThemeColor();
public native void stylesInitialized();
public native void clearStyle(String arg0);
public native intrinsic.Array getClassStyleDeclarations();
public native intrinsic.flash.geom.Point contentToGlobal(intrinsic.flash.geom.Point arg0);
public native void styleChanged(String arg0);
public native void registerEffects(intrinsic.Array arg0);
public native intrinsic.flash.display.DisplayObject $addChildAt(intrinsic.flash.display.DisplayObject arg0, int arg1);
public native void validateProperties();
public native void validateDisplayList();
public native void setActualSize(double arg0, double arg1);
public native void effectStarted(intrinsic.mx.effects.EffectInstance arg0);
public native void validateSize();
public native void validateSize(boolean arg0);
public native Object createAutomationIDPart(intrinsic.mx.automation.IAutomationObject arg0);
public native double getExplicitOrMeasuredHeight();
public native intrinsic.mx.automation.IAutomationObject getAutomationChildAt(int arg0);
public native void notifyStyleChangeInChildren(String arg0, boolean arg1);
public native boolean replayAutomatableEvent(intrinsic.flash.events.Event arg0);
public native intrinsic.Array resolveAutomationIDPart(Object arg0);
public native void finishPrint(Object arg0, intrinsic.mx.core.IFlexDisplayObject arg1);
public native void drawFocus(boolean arg0);
public native void updateCallbacks();
public native Object prepareToPrint(intrinsic.mx.core.IFlexDisplayObject arg0);
public native void createReferenceOnParentDocument(intrinsic.mx.core.IFlexDisplayObject arg0);
public native void executeBindings();
public native void executeBindings(boolean arg0);
public native void deleteReferenceOnParentDocument(intrinsic.mx.core.IFlexDisplayObject arg0);
public native void validationResultHandler(intrinsic.mx.events.ValidationResultEvent arg0);
public native void setConstraintValue(String arg0, Object arg1);
public native double getExplicitOrMeasuredWidth();
public native Object getConstraintValue(String arg0);
public native intrinsic.flash.geom.Point localToContent(intrinsic.flash.geom.Point arg0);
public native void setUnscaledWidth(double arg0);
public native intrinsic.flash.geom.Matrix verticalGradientMatrix(double arg0, double arg1, double arg2, double arg3);
public native void setCurrentState(String arg0);
public native void setCurrentState(String arg0, boolean arg1);
public native void setUnscaledHeight(double arg0);
public native intrinsic.flash.display.DisplayObject $removeChild(intrinsic.flash.display.DisplayObject arg0);
public native intrinsic.flash.geom.Matrix horizontalGradientMatrix(double arg0, double arg1, double arg2, double arg3);
public native boolean hasFontContextChanged();
public native void initializeRepeaterArrays(intrinsic.mx.core.IRepeaterClient arg0);
public native void addOverlay(int arg0);
public native void addOverlay(int arg0, intrinsic.mx.graphics.RoundedRectangle arg1);
public native void callLater(intrinsic.Function arg0);
public native void callLater(intrinsic.Function arg0, intrinsic.Array arg1);
public native intrinsic.flash.text.TextLineMetrics measureHTMLText(String arg0);
public native intrinsic.mx.core.EmbeddedFont getEmbeddedFont(String arg0, boolean arg1, boolean arg2);
public native intrinsic.flash.geom.Point contentToLocal(intrinsic.flash.geom.Point arg0);
public native void initProtoChain();
public native void adjustSizesForScaleChanges();
public native intrinsic.mx.core.UITextFormat determineTextFormatFromStyles();
public native void regenerateStyleCache(boolean arg0);
public native boolean owns(intrinsic.flash.display.DisplayObject arg0);
public native void move(double arg0, double arg1);
public native void childAdded(intrinsic.flash.display.DisplayObject arg0);
public native void setChildIndex(intrinsic.flash.display.DisplayObject arg0, int arg1);
public native void stopDrag();
public native intrinsic.flash.display.DisplayObject addChildAt(intrinsic.flash.display.DisplayObject arg0, int arg1);
public native void invalidateDisplayList();
public native void endEffectsStarted();
public native void setThemeColor(Object arg0);
public native void childRemoved(intrinsic.flash.display.DisplayObject arg0);
public native intrinsic.flash.display.DisplayObject addChild(intrinsic.flash.display.DisplayObject arg0);
public native intrinsic.flash.display.DisplayObject $removeChildAt(int arg0);
public native void cancelAllCallLaters();
public native Object getRepeaterItem();
public native Object getRepeaterItem(int arg0);
public native intrinsic.flash.display.DisplayObject $addChild(intrinsic.flash.display.DisplayObject arg0);
protected native void updateDisplayList(double unscaledWidth, double unscaledHeight);
protected native void createChildren(); 
}
